diff --git a/src/test/regression/tests/042.track_table_mutation/test.sh b/src/test/regression/tests/042.track_table_mutation/test.sh
new file mode 100755
index 0000000000000000000000000000000000000000..8b4dd17b820d36e3fc48216ac7f0544cbf0f5a9c
--- /dev/null
+++ b/src/test/regression/tests/042.track_table_mutation/test.sh
@@ -0,0 +1,354 @@
+#!/usr/bin/env bash
+#-------------------------------------------------------------------
+# test script for track table mutation feature (in-memory table tracking).
+# Tests routing of queries based on recently written tables.
+#
+source $TESTLIBS
+TESTDIR=testdir
+PSQL=$PGBIN/psql
+PSQLOPTS="-a -q -X"
+PGPOOLBIN=$PGPOOL_INSTALL_DIR/bin
+export PGDATABASE=test
+
+# Only run in streaming replication mode since that's the target use case
+for mode in s
+do
+    rm -fr $TESTDIR
+    mkdir $TESTDIR
+    cd $TESTDIR
+
+    # Create test environment with 2 nodes
+    echo -n "creating test environment..."
+    $PGPOOL_SETUP -m $mode -n 2 || exit 1
+    echo "done."
+
+    source ./bashrc.ports
+
+    # Configure track table mutation feature via dml_adaptive_global
+    echo "disable_load_balance_on_write = 'dml_adaptive_global'" >> etc/pgpool.conf
+    echo "track_table_mutation_ttl_factor = 5.0" >> etc/pgpool.conf
+    echo "track_table_mutation_cold_start_duration = 10000" >> etc/pgpool.conf
+
+    # Enable load balancing explicitly
+    echo "load_balance_mode = on" >> etc/pgpool.conf
+
+    # Configure weights so we can distinguish routing
+    # Backend 0 (primary) weight=0, Backend 1 (standby) weight=1
+    # This means load balanced queries go to node 1 by default
+    echo "backend_weight0 = 0" >> etc/pgpool.conf
+    echo "backend_weight1 = 1" >> etc/pgpool.conf
+
+    # Enable debug logging to see routing decisions
+    echo "log_min_messages = debug1" >> etc/pgpool.conf
+
+    ./startall
+
+    export PGPORT=$PGPOOL_PORT
+    export PGHOST=localhost
+
+    wait_for_pgpool_startup
+
+    # Create test tables
+    $PSQL test <<EOF
+CREATE TABLE t1(i INTEGER);
+CREATE TABLE t2(i INTEGER);
+CREATE TABLE t3(i INTEGER);
+EOF
+
+    echo "=== Test 1: Cold Start Routing ==="
+    # During cold start, all queries should go to primary
+    # Restart pgpool to trigger cold start
+    ./shutdownall
+    ./startall
+    wait_for_pgpool_startup
+
+    # Immediately query - should go to primary due to cold start
+    $PSQL test -c "SELECT 'cold_start_test' as marker, * FROM t1;" > /dev/null 2>&1
+
+    # Check log for cold start message (use -a to handle binary log files)
+    if grep -a -q "could not load balance because of track table mutation cold start" log/pgpool.log; then
+        echo "Test 1 PASSED: Cold start routing works"
+    else
+        echo "Test 1 FAILED: Cold start routing not detected"
+        ./shutdownall
+        exit 1
+    fi
+
+    echo "=== Test 2: Wait for cold start to end ==="
+    # Wait for cold start period to end (10 seconds).
+    # Use generous margin to avoid flakiness under load (e.g. full regression suite).
+    sleep 12
+
+    # Clear the log
+    > log/pgpool.log
+
+    # Now a clean table query should load balance (go to node 1)
+    $PSQL test -c "SELECT 'after_cold_start' as marker, * FROM t3;" > /dev/null 2>&1
+
+    # After cold start, queries to clean tables should load balance
+    # Check that it did NOT get forced to primary due to track table mutation
+    if grep -a -q "could not load balance because of track table mutation cold start" log/pgpool.log; then
+        echo "Test 2 FAILED: Still in cold start after waiting"
+        ./shutdownall
+        exit 1
+    fi
+    echo "Test 2 PASSED: Cold start ended correctly"
+
+    echo "=== Test 3: Write-then-Read Routing ==="
+    # Clear the log
+    > log/pgpool.log
+
+    # Write to t1 and then read - use single connection to ensure same session
+    $PSQL test <<EOF
+INSERT INTO t1 VALUES (1);
+SELECT 'write_read_test' as marker, * FROM t1;
+EOF
+
+    # Small delay to ensure log is flushed
+    sleep 0.5
+
+    # Check log for table staleness message
+    if grep -a -q "could not load balance because table.*was recently written" log/pgpool.log; then
+        echo "Test 3 PASSED: Write-then-read routing works"
+    else
+        echo "Test 3 FAILED: Table staleness not detected after write"
+        # Show relevant log entries for debugging
+        grep -a -i "track_table_mutation" log/pgpool.log | tail -20
+        ./shutdownall
+        exit 1
+    fi
+
+    echo "=== Test 4: Clean Table Still Load Balances ==="
+    # Clear the log
+    > log/pgpool.log
+
+    # Read from t2 (never written to) - should load balance
+    $PSQL test -c "SELECT 'clean_table_test' as marker, * FROM t2;" > /dev/null 2>&1
+
+    # Should NOT see track table mutation blocking message for t2
+    if grep -a -q "could not load balance because table.*t2.*was recently written" log/pgpool.log; then
+        echo "Test 4 FAILED: Clean table incorrectly marked as stale"
+        ./shutdownall
+        exit 1
+    fi
+    echo "Test 4 PASSED: Clean tables still load balance"
+
+    echo "=== Test 5: UPDATE Marks Table as Stale ==="
+    # Clear the log
+    > log/pgpool.log
+
+    # Update t2 and then read - use single connection
+    $PSQL test <<EOF
+UPDATE t2 SET i = 999 WHERE i = 0;
+SELECT 'update_test' as marker, * FROM t2;
+EOF
+
+    # Small delay to ensure log is flushed
+    sleep 0.5
+
+    if grep -a -q "could not load balance because table.*was recently written" log/pgpool.log; then
+        echo "Test 5 PASSED: UPDATE marks table as stale"
+    else
+        echo "Test 5 FAILED: UPDATE did not mark table as stale"
+        ./shutdownall
+        exit 1
+    fi
+
+    echo "=== Test 6: DELETE Marks Table as Stale ==="
+    # Clear the log
+    > log/pgpool.log
+
+    # Delete from t3 and then read - use single connection
+    $PSQL test <<EOF
+DELETE FROM t3 WHERE i = 0;
+SELECT 'delete_test' as marker, * FROM t3;
+EOF
+
+    # Small delay to ensure log is flushed
+    sleep 0.5
+
+    if grep -a -q "could not load balance because table.*was recently written" log/pgpool.log; then
+        echo "Test 6 PASSED: DELETE marks table as stale"
+    else
+        echo "Test 6 FAILED: DELETE did not mark table as stale"
+        ./shutdownall
+        exit 1
+    fi
+
+    echo "=== Test 7: TRUNCATE Marks Table as Stale ==="
+    # Clear the log
+    > log/pgpool.log
+
+    # Create a fresh table for TRUNCATE test
+    $PSQL test -c "CREATE TABLE t_truncate(i INTEGER);" > /dev/null 2>&1
+    $PSQL test -c "INSERT INTO t_truncate VALUES (1), (2), (3);" > /dev/null 2>&1
+
+    # Wait for any TTL to expire
+    sleep 3
+
+    # Clear the log again
+    > log/pgpool.log
+
+    # Truncate and then read - use single connection
+    $PSQL test <<EOF
+TRUNCATE t_truncate;
+SELECT 'truncate_test' as marker, * FROM t_truncate;
+EOF
+
+    # Small delay to ensure log is flushed
+    sleep 0.5
+
+    if grep -a -q "could not load balance because table.*was recently written" log/pgpool.log; then
+        echo "Test 7 PASSED: TRUNCATE marks table as stale"
+    else
+        echo "Test 7 FAILED: TRUNCATE did not mark table as stale"
+        grep -a -i "track_table_mutation" log/pgpool.log | tail -20
+        ./shutdownall
+        exit 1
+    fi
+
+    echo "=== Test 8: WITH Clause (CTE with DELETE) Marks Table as Stale ==="
+    # Clear the log
+    > log/pgpool.log
+
+    # Create a fresh table for WITH test
+    $PSQL test -c "CREATE TABLE t_cte(i INTEGER);" > /dev/null 2>&1
+    $PSQL test -c "INSERT INTO t_cte VALUES (1), (2), (3);" > /dev/null 2>&1
+
+    # Wait for any TTL to expire
+    sleep 3
+
+    # Clear the log again
+    > log/pgpool.log
+
+    # Use WITH clause with DELETE, then read from the table
+    $PSQL test <<EOF
+WITH deleted AS (DELETE FROM t_cte WHERE i = 1 RETURNING *)
+SELECT * FROM deleted;
+SELECT 'cte_test' as marker, * FROM t_cte;
+EOF
+
+    # Small delay to ensure log is flushed
+    sleep 0.5
+
+    if grep -a -q "could not load balance because table.*was recently written" log/pgpool.log; then
+        echo "Test 8 PASSED: WITH clause (CTE) marks table as stale"
+    else
+        echo "Test 8 FAILED: WITH clause (CTE) did not mark table as stale"
+        grep -a -i "track_table_mutation" log/pgpool.log | tail -20
+        ./shutdownall
+        exit 1
+    fi
+
+    # Test 9: MERGE (PostgreSQL 15+ only)
+    PG_MAJOR_VERSION=$($PSQL -t -c "SELECT substring(version() from 'PostgreSQL ([0-9]+)');" | tr -d ' ')
+    if [ "$PG_MAJOR_VERSION" -ge 15 ] 2>/dev/null; then
+        echo "=== Test 9: MERGE Marks Table as Stale (PostgreSQL $PG_MAJOR_VERSION) ==="
+        # Clear the log
+        > log/pgpool.log
+
+        # Create tables for MERGE test
+        $PSQL test -c "CREATE TABLE t_merge_target(id INTEGER PRIMARY KEY, val TEXT);" > /dev/null 2>&1
+        $PSQL test -c "CREATE TABLE t_merge_source(id INTEGER, val TEXT);" > /dev/null 2>&1
+        $PSQL test -c "INSERT INTO t_merge_target VALUES (1, 'old');" > /dev/null 2>&1
+        $PSQL test -c "INSERT INTO t_merge_source VALUES (1, 'new'), (2, 'insert');" > /dev/null 2>&1
+
+        # Wait for any TTL to expire
+        sleep 3
+
+        # Clear the log again
+        > log/pgpool.log
+
+        # Use MERGE, then read from the target table
+        $PSQL test <<EOF
+MERGE INTO t_merge_target t
+USING t_merge_source s ON t.id = s.id
+WHEN MATCHED THEN UPDATE SET val = s.val
+WHEN NOT MATCHED THEN INSERT VALUES (s.id, s.val);
+SELECT 'merge_test' as marker, * FROM t_merge_target;
+EOF
+
+        # Small delay to ensure log is flushed
+        sleep 0.5
+
+        if grep -a -q "could not load balance because table.*was recently written" log/pgpool.log; then
+            echo "Test 9 PASSED: MERGE marks table as stale"
+        else
+            echo "Test 9 FAILED: MERGE did not mark table as stale"
+            grep -a -i "track_table_mutation" log/pgpool.log | tail -20
+            ./shutdownall
+            exit 1
+        fi
+    else
+        echo "=== Test 9: MERGE skipped (requires PostgreSQL 15+, have $PG_MAJOR_VERSION) ==="
+    fi
+
+    echo "=== Test 10: ROLLBACK Does NOT Mark Table as Stale ==="
+    # Create a fresh table for rollback test
+    $PSQL test -c "CREATE TABLE t_rollback(i INTEGER);" > /dev/null 2>&1
+
+    # Wait for any TTL to expire
+    sleep 3
+
+    # Clear the log
+    > log/pgpool.log
+
+    # Write inside a transaction, then rollback
+    $PSQL test <<EOF
+BEGIN;
+INSERT INTO t_rollback VALUES (1);
+ROLLBACK;
+SELECT 'rollback_test' as marker, * FROM t_rollback;
+EOF
+
+    # Small delay to ensure log is flushed
+    sleep 0.5
+
+    # Should NOT see t_rollback marked as stale since the write was rolled back
+    if grep -a -q "could not load balance because table.*t_rollback.*was recently written" log/pgpool.log; then
+        echo "Test 10 FAILED: Rolled-back write incorrectly marked table as stale"
+        grep -a -i "track_table_mutation" log/pgpool.log | tail -20
+        ./shutdownall
+        exit 1
+    fi
+    echo "Test 10 PASSED: ROLLBACK does not mark table as stale"
+
+    echo "=== Test 11: COMMIT Marks Table as Stale ==="
+    # Create a fresh table for commit test
+    $PSQL test -c "CREATE TABLE t_commit(i INTEGER);" > /dev/null 2>&1
+
+    # Wait for any TTL to expire
+    sleep 3
+
+    # Clear the log
+    > log/pgpool.log
+
+    # Write inside a transaction, then commit, then read
+    $PSQL test <<EOF
+BEGIN;
+INSERT INTO t_commit VALUES (1);
+COMMIT;
+SELECT 'commit_test' as marker, * FROM t_commit;
+EOF
+
+    # Small delay to ensure log is flushed
+    sleep 0.5
+
+    if grep -a -q "could not load balance because table.*was recently written" log/pgpool.log; then
+        echo "Test 11 PASSED: COMMIT marks table as stale"
+    else
+        echo "Test 11 FAILED: Committed write did not mark table as stale"
+        grep -a -i "track_table_mutation" log/pgpool.log | tail -20
+        ./shutdownall
+        exit 1
+    fi
+
+    echo ""
+    echo "=== All Track Table Mutation Tests PASSED ==="
+
+    ./shutdownall
+
+    cd ..
+done
+
+exit 0
diff --git a/src/test/regression/tests/043.track_table_mutation_watchdog/.gitignore b/src/test/regression/tests/043.track_table_mutation_watchdog/.gitignore
new file mode 100644
index 0000000000000000000000000000000000000000..fcb93d27a7e7e8a5efe6eacfb0f88f6f3c8bc765
--- /dev/null
+++ b/src/test/regression/tests/043.track_table_mutation_watchdog/.gitignore
@@ -0,0 +1,3 @@
+leader
+standby
+*.pid
diff --git a/src/test/regression/tests/043.track_table_mutation_watchdog/leader.conf b/src/test/regression/tests/043.track_table_mutation_watchdog/leader.conf
new file mode 100644
index 0000000000000000000000000000000000000000..945cff9860d0357fbb0e3e9a5643124d916bd9c3
--- /dev/null
+++ b/src/test/regression/tests/043.track_table_mutation_watchdog/leader.conf
@@ -0,0 +1,25 @@
+# leader watchdog config for track_table_mutation watchdog test
+use_watchdog = on
+wd_interval = 1
+wd_priority = 2
+
+hostname0 = 'localhost'
+wd_port0 = 21004
+pgpool_port0 = 11000
+hostname1 = 'localhost'
+wd_port1 = 21104
+pgpool_port1 = 11100
+
+heartbeat_hostname0 = 'localhost'
+heartbeat_port0 = 21005
+heartbeat_hostname1 = 'localhost'
+heartbeat_port1 = 21105
+
+enable_consensus_with_half_votes = on
+
+# Enable track table mutation feature via dml_adaptive_global
+disable_load_balance_on_write = 'dml_adaptive_global'
+track_table_mutation_cold_start_duration = 2000
+
+# Enable debug logging to see feature messages
+log_min_messages = debug1
diff --git a/src/test/regression/tests/043.track_table_mutation_watchdog/standby.conf b/src/test/regression/tests/043.track_table_mutation_watchdog/standby.conf
new file mode 100644
index 0000000000000000000000000000000000000000..a11c3dfca427cf6b246451d067c30b0255b9c4ce
--- /dev/null
+++ b/src/test/regression/tests/043.track_table_mutation_watchdog/standby.conf
@@ -0,0 +1,27 @@
+# standby watchdog config for track_table_mutation watchdog test
+port = 11100
+pcp_port = 11105
+use_watchdog = on
+wd_interval = 1
+wd_priority = 1
+
+hostname0 = 'localhost'
+wd_port0 = 21004
+pgpool_port0 = 11000
+hostname1 = 'localhost'
+wd_port1 = 21104
+pgpool_port1 = 11100
+
+heartbeat_hostname0 = 'localhost'
+heartbeat_port0 = 21005
+heartbeat_hostname1 = 'localhost'
+heartbeat_port1 = 21105
+
+enable_consensus_with_half_votes = on
+
+# Enable track table mutation feature via dml_adaptive_global
+disable_load_balance_on_write = 'dml_adaptive_global'
+track_table_mutation_cold_start_duration = 2000
+
+# Enable debug logging to see feature messages
+log_min_messages = debug1
diff --git a/src/test/regression/tests/043.track_table_mutation_watchdog/test.sh b/src/test/regression/tests/043.track_table_mutation_watchdog/test.sh
new file mode 100755
index 0000000000000000000000000000000000000000..752a6e6aa377fe0c54244975e606648101c98cf8
--- /dev/null
+++ b/src/test/regression/tests/043.track_table_mutation_watchdog/test.sh
@@ -0,0 +1,179 @@
+#!/usr/bin/env bash
+#-------------------------------------------------------------------
+# test script for track table mutation global cold start on watchdog leader change.
+# Tests that when the watchdog leader changes, the new leader triggers
+# a global cold start to force all queries to primary.
+#
+source $TESTLIBS
+LEADER_DIR=leader
+STANDBY_DIR=standby
+PSQL=$PGBIN/psql
+success_count=0
+
+rm -fr $LEADER_DIR
+rm -fr $STANDBY_DIR
+
+mkdir $LEADER_DIR
+mkdir $STANDBY_DIR
+
+# dir in leader directory
+cd $LEADER_DIR
+
+# create leader environment with streaming replication
+echo -n "creating leader pgpool..."
+$PGPOOL_SETUP -m s -n 2 -p 11000 || exit 1
+echo "leader setup done."
+
+# copy the configurations to standby
+cp -r etc ../$STANDBY_DIR/
+
+source ./bashrc.ports
+cat ../leader.conf >> etc/pgpool.conf
+echo 0 > etc/pgpool_node_id
+
+./startall
+wait_for_pgpool_startup
+
+# back to test root dir
+cd ..
+
+# create standby environment
+mkdir $STANDBY_DIR/log
+echo -n "creating standby pgpool..."
+cat standby.conf >> $STANDBY_DIR/etc/pgpool.conf
+# since we are using the same pgpool-II conf as of leader, change the pid file path
+echo "pid_file_name = '$PWD/pgpool2.pid'" >> $STANDBY_DIR/etc/pgpool.conf
+echo 1 > $STANDBY_DIR/etc/pgpool_node_id
+# start the standby pgpool-II by hand
+$PGPOOL_INSTALL_DIR/bin/pgpool -D -n -f $STANDBY_DIR/etc/pgpool.conf -F $STANDBY_DIR/etc/pcp.conf -a $STANDBY_DIR/etc/pool_hba.conf > $STANDBY_DIR/log/pgpool.log 2>&1 &
+
+# Test 1: Check if leader pgpool-II started correctly
+echo "=== Test 1: Waiting for the pgpool leader... ==="
+for i in 1 2 3 4 5 6 7 8 9 10
+do
+	grep "I am the cluster leader node. Starting escalation process" $LEADER_DIR/log/pgpool.log > /dev/null 2>&1
+	if [ $? = 0 ]; then
+		success_count=$(( success_count + 1 ))
+		echo "Test 1 PASSED: Leader brought up successfully."
+		break
+	fi
+	echo "[check] $i times"
+	sleep 2
+done
+
+if [ $success_count -lt 1 ]; then
+	echo "Test 1 FAILED: Leader did not start"
+	$PGPOOL_INSTALL_DIR/bin/pgpool -f $STANDBY_DIR/etc/pgpool.conf -m f stop 2>/dev/null
+	cd $LEADER_DIR && ./shutdownall
+	exit 1
+fi
+
+# Test 2: Check if standby has successfully joined
+echo "=== Test 2: Waiting for the standby to join cluster... ==="
+for i in 1 2 3 4 5 6 7 8 9 10
+do
+	grep "successfully joined the watchdog cluster as standby node" $STANDBY_DIR/log/pgpool.log > /dev/null 2>&1
+	if [ $? = 0 ]; then
+		success_count=$(( success_count + 1 ))
+		echo "Test 2 PASSED: Standby successfully connected."
+		break
+	fi
+	echo "[check] $i times"
+	sleep 2
+done
+
+if [ $success_count -lt 2 ]; then
+	echo "Test 2 FAILED: Standby did not join cluster"
+	$PGPOOL_INSTALL_DIR/bin/pgpool -f $STANDBY_DIR/etc/pgpool.conf -m f stop 2>/dev/null
+	cd $LEADER_DIR && ./shutdownall
+	exit 1
+fi
+
+# Test 3: Verify track_table_mutation is enabled and working on leader
+echo "=== Test 3: Verify track_table_mutation is enabled ==="
+if grep -a "track_table_mutation: initialized" $LEADER_DIR/log/pgpool.log > /dev/null 2>&1; then
+	success_count=$(( success_count + 1 ))
+	echo "Test 3 PASSED: track_table_mutation initialized on leader"
+else
+	echo "Test 3 FAILED: track_table_mutation not initialized on leader"
+	$PGPOOL_INSTALL_DIR/bin/pgpool -f $STANDBY_DIR/etc/pgpool.conf -m f stop 2>/dev/null
+	cd $LEADER_DIR && ./shutdownall
+	exit 1
+fi
+
+# Test 4: Stop leader pgpool and trigger failover
+echo "=== Test 4: Triggering leader failover... ==="
+$PGPOOL_INSTALL_DIR/bin/pgpool -f $LEADER_DIR/etc/pgpool.conf -m f stop
+
+echo "Checking if the Standby pgpool-II detected the leader shutdown..."
+for i in 1 2 3 4 5 6 7 8 9 10
+do
+	grep -a " is shutting down" $STANDBY_DIR/log/pgpool.log > /dev/null 2>&1
+	if [ $? = 0 ]; then
+		success_count=$(( success_count + 1 ))
+		echo "Test 4 PASSED: Leader shutdown detected."
+		break
+	fi
+	echo "[check] $i times"
+	sleep 2
+done
+
+if [ $success_count -lt 4 ]; then
+	echo "Test 4 FAILED: Leader shutdown not detected"
+	$PGPOOL_INSTALL_DIR/bin/pgpool -f $STANDBY_DIR/etc/pgpool.conf -m f stop 2>/dev/null
+	cd $LEADER_DIR && ./shutdownall
+	exit 1
+fi
+
+# Test 5: Verify standby becomes new leader
+echo "=== Test 5: Checking if standby takes over as leader... ==="
+for i in 1 2 3 4 5 6 7 8 9 10
+do
+	grep -a "I am the cluster leader node. Starting escalation process" $STANDBY_DIR/log/pgpool.log > /dev/null 2>&1
+	if [ $? = 0 ]; then
+		success_count=$(( success_count + 1 ))
+		echo "Test 5 PASSED: Standby became the new leader."
+		break
+	fi
+	echo "[check] $i times"
+	sleep 2
+done
+
+if [ $success_count -lt 5 ]; then
+	echo "Test 5 FAILED: Standby did not become leader"
+	$PGPOOL_INSTALL_DIR/bin/pgpool -f $STANDBY_DIR/etc/pgpool.conf -m f stop 2>/dev/null
+	cd $LEADER_DIR && ./shutdownall
+	exit 1
+fi
+
+# Test 6: Verify global cold start was triggered on new leader
+echo "=== Test 6: Checking if global cold start was triggered... ==="
+# The new leader should trigger global cold start when it becomes coordinator
+# Look for the log message that indicates global cold start was triggered
+for i in 1 2 3 4 5 6 7 8 9 10
+do
+	grep -a "track_table_mutation: entering global cold start" $STANDBY_DIR/log/pgpool.log > /dev/null 2>&1
+	if [ $? = 0 ]; then
+		success_count=$(( success_count + 1 ))
+		echo "Test 6 PASSED: Global cold start triggered on new leader."
+		break
+	fi
+	echo "[check] $i times"
+	sleep 2
+done
+
+# Cleanup
+$PGPOOL_INSTALL_DIR/bin/pgpool -f $STANDBY_DIR/etc/pgpool.conf -m f stop 2>/dev/null
+cd $LEADER_DIR
+./shutdownall
+
+echo ""
+echo "$success_count out of 6 successful"
+
+if test $success_count -eq 6
+then
+	echo "=== All Track Table Mutation Watchdog Tests PASSED ==="
+	exit 0
+fi
+
+exit 1
